// circle racer

// x-positions of all racers
let x = [];

function setup() {
  createCanvas(300, 300);

  // initialize starting position of all racers
  for (let i = 0; i < 6; i++) {
    x[i] = random(0,width);
  }
}

function draw() {
  background(220); // grey
  
  for (let i = 0; i < x.length; i++) {
    // calculate the y position
    let y = 40 * (i + 1);
    // use array element for x position of each racer
    racerDraw(x[i], y, i + 1);
    // update the position of racer's array element
    x[i] += random(0, 0.6);
    if (x[i] > width) {
      x[i] -= width;
    }
  }
}

function keyTyped() {
  let keyParsed = int(key);
  if (0 <= keyParsed && keyParsed < x.length) {
    disqualifyAt(keyParsed);
  }
}

function disqualifyAt(i) {
  removeElementAt(x, i);
}

// racer - - - - - - - - - - - - - - - - - -

// draw a 30px diameter racer at position x,y 
// showing the racer number
function racerDraw(x, y,  number) {
  let s = 30;
  // draw the racer body
  fill(255);
  ellipse(x, y, s, s);
  // draw the race number in the centre
  textAlign(CENTER, CENTER);
  textSize(20);
  fill(0);
  text(number, x, y);  
}

// array mechanics - - - - - - - - - - - - -
  
// modifies arr to remove an item that was initially in arr[i];
// shifts later elements forward, and reduces arr.length, by one
function removeElementAt(arr, i) {
  arr.splice(i, 1);
}
