// circle racer

// x-positions of all racers
let x = [];
let label = [];
let r = [];
let g = [];
let b = [];

function setup() {
  createCanvas(300, 300);

  // initialize label and starting position of all racers
  for (let i = 0; i < 6; i++) {
    x[i] = random(0,width);
    label[i] = i + 1;
    r[i] = random(0,256);
    g[i] = random(0,256);
    b[i] = random(0,256);
  }
}

function draw() {
  background(220); // grey
  
  for (let i = 0; i < x.length; i++) {
    // calculate the y position
    let y = 40 * (i + 1);
    // use array element for x position of each racer
    racerDraw(x[i], y, label[i], r[i], g[i], b[i]);
    // update the position of racer's array element
    x[i] += random(0, 0.6);
    if (x[i] > width) {
      x[i] -= width;
    }
  }
}

function keyTyped() {
  let keyParsed = int(key);
  if (0 <= keyParsed && keyParsed < x.length) {
    disqualifyAt(keyParsed);
  }
}

function disqualifyAt(i) {
  removeElementAt(x, i);
  removeElementAt(label, i);
  removeElementAt(r, i);
  removeElementAt(g, i);
  removeElementAt(b, i);
}

// racer - - - - - - - - - - - - - - - - - -

// draw a 30px diameter racer at position x,y 
// showing the racer number
function racerDraw(x, y,  number, r, g, b) {
  let s = 30;
  // draw the racer body
  fill(r, g, b);
  ellipse(x, y, s, s);
  // draw the race number in the centre; use inverse color
  textAlign(CENTER, CENTER);
  textSize(20);
  fill(256-r, 256-g, 256-b);
  text(number, x, y);  
}

// array mechanics - - - - - - - - - - - - -
  
// modifies arr to remove an item that was initially in arr[i];
// shifts later elements forward, and reduces arr.length, by one
function removeElementAt(arr, i) {
  arr.splice(i, 1);
}
