// circle racer

// all data of all racers
let racer = [];

function setup() {
  createCanvas(300, 300);

  // initialize label and starting position of all racers
  for (let i = 0; i < 6; i++) {
    racer[i] = {};
    racer[i].x = random(0,width);
    racer[i].label = i + 1;
    racer[i].r = random(0,256);
    racer[i].g = random(0,256);
    racer[i].b = random(0,256);
  }
}

function draw() {
  background(220); // grey
  
  for (let i = 0; i < racer.length; i++) {
    // calculate the y position
    let y = 40 * (i + 1);
    // use array element for x position of each racer
    racerDraw(racer[i].x, y, racer[i].label, racer[i].r, racer[i].g, racer[i].b);
    // update the position of racer's array element
    racer[i].x += random(0, 0.6);
    if (racer[i].x > width) {
      racer[i].x -= width;
    }
  }
}

function keyTyped() {
  let keyParsed = int(key);
  if (0 <= keyParsed && keyParsed < racer.length) {
    disqualifyAt(keyParsed);
  }
}

function disqualifyAt(i) {
  removeElementAt(racer, i);
}

// racer - - - - - - - - - - - - - - - - - -

// draw a 30px diameter racer at position x,y 
// showing the racer number
function racerDraw(x, y,  number, r, g, b) {
  let s = 30;
  // draw the racer body
  fill(r, g, b);
  ellipse(x, y, s, s);
  // draw the race number in the centre; use inverse color
  textAlign(CENTER, CENTER);
  textSize(20);
  fill(256-r, 256-g, 256-b);
  text(number, x, y);  
}

// array mechanics - - - - - - - - - - - - -
  
// modifies arr to remove an item that was initially in arr[i];
// shifts later elements forward, and reduces arr.length, by one
function removeElementAt(arr, i) {
  arr.splice(i, 1);
}
